/* @(#)getargs.c	1.3.1.3                    10/27/89 */
/*
 * Command line argument processor for C programs. All types and
 * defines are defined in the file getargs.h
 *
 * 28/04/89 (raw): SCCS keywords; use "#if defined" constructs
 * 25/09/89 (mm ): defined DBSD101 (DOMAIN 10.1 Bsd 4.3)
 *
 * xx.05.90 kk  Version 2.0
 *              Beware! For practical reasons this file is duplicated
 *              in nc and ncgen directory. Copy if you modify it.
 *  5.06.90 kk  replaced DBSD... by  apollo for the above
 * 12.06.90 kk  replaced NULL by '\0' in two cases
 *  6.06.91 kk  commented out 2 lines in pr_usage() which are useless but
 *              cause code generated by GNU gcc core dump.
 */

#include "sysconfig.h"
#include "stdio.h"
#include "getargs.h"


#define ERRINT "Getargs: illegal option type"
#define MAXSTR 128

typedef int     (*PFI)();

/*
 * The Apollo error device (stderr) is very slow. Therefore it is
 * replaced by stdout for display of menus.
 */

#if defined(apollo)
#undef  stderr
#define stderr stdout
#endif

/*
 * Set an argument. argp points to the argument table entry
 * corresponding to *linep. Return linep, updated to point
 * past the argument being set.
 */

static char     *setarg( prog_name, headp, argp, linep, pargc, pargv )
char            *prog_name;
GA_HEAD         *headp;
GA_ARG          *argp;
char            *linep;
int             *pargc;
char            ***pargv;
{
	char    *part1;
	char    copy_buf[MAXSTR];

        if( argp->ga_type & GA_NAVAIL )
        {
		(* (PFI)(headp->ga_error) )( prog_name, *headp->ga_notavail, *linep );
                linep = "";
                return( linep );
        }
        else if( argp->ga_type & GA_SPACE )
        {
                (*pargv)++; (*pargc)--;
                linep = **pargv;
        }
        else
                ++linep;

        switch( argp->ga_type & GA_TYPE )
        {
                case GA_BOOLEAN:
                        *argp->ga_variable = (*argp->ga_variable) ? 0 : 1;
                        break;

                case GA_INT:
                        *argp->ga_variable = stoi( &linep );
                        break;

                case GA_CHAR:
                        *argp->ga_variable = *linep++;
                        break;

                case GA_STRING:
                        *(char **)argp->ga_variable = linep;
                        linep = "";
                        break;

                case GA_PROC:
                        (* (PFI)(argp->ga_variable) )( linep );
                        linep = "";
                        break;

		case GA_COPY:
			if( argp->ga_type & GA_SPACE ) {
				(*pargv)--;
				part1 = **pargv;
				strcpy( copy_buf, part1 );
				strcat( copy_buf, " " );
				strcat( copy_buf, linep );
				(*pargv)++;
				(* (PFI)(argp->ga_variable) )( copy_buf );
			} else {
				(* (PFI)(argp->ga_variable) )( linep-2 );
			}
                        linep = "";
                        break;

                case GA_HELP:
                        (* (PFI)(argp->ga_variable) )( headp, linep );
                        linep = "";
                        break;

                default:
			(* (PFI)(headp->ga_error) )( prog_name, ERRINT );
                        break;
        }
        return( linep );
}


/*
 * Return pointer to argument table entry corresponding to c,
 * or 0 if c is not in table.
 */

static GA_ARG   *findarg( c, tabp, tabsize )
int             c, tabsize;
GA_ARG          *tabp;
{
        for( ; --tabsize >= 0; tabp++ )
                if( tabp->ga_arg == c )
                        return( tabp );
        return( NULL );
}


/*
 * Print a line of characters given in c of length l.
 */

static  pr_line( c, l )
char    c;
int     l;
{
        register int    i;

        for( i = 0; i < l; i++ )
                putc( c, stderr );
}


/*
 * Print the leadin text for each option.
 */

static  pr_option( tabp )
GA_ARG  *tabp;
{
        register int    i = 0;
        register char   *cp;

        fprintf( stderr, "-%c", tabp->ga_arg );

        if( tabp->ga_type & GA_SPACE )
        {
                putc( ' ', stderr );
                i++;
        }

        for( cp = tabp->ga_text; *cp && i < 10; i++ )
                putc( *cp++, stderr );

        while( i++ < 10 )
                putc( '.', stderr );

        putc( ' ', stderr );
}


/*
 * Print the contents of the argument table.
 */

static  pr_usage( prog_name, headp, tabp, tabsize )
char    *prog_name;
int     tabsize;
GA_ARG  *tabp;
GA_HEAD *headp;
{
        char    cc;
	char    ht1[MAXSTR];

        pr_line( headp->ga_hor, 79 ); putc( '\n', stderr );
	sprintf( ht1, headp->ga_ht1, prog_name );
	fprintf( stderr, "%-50s%29s\n", ht1, headp->ga_ht2 );
        pr_line( headp->ga_hor, 79 ); putc( '\n', stderr );

        for( ; --tabsize >= 0; tabp++ )
        {
                if( tabp->ga_type & GA_HIDE )
                        continue;

                pr_option( tabp );

                switch( tabp->ga_type & GA_TYPE )
                {
                case GA_BOOLEAN:
                        fprintf( stderr, "__%-7s", *(tabp->ga_variable) ? "TRUE" : "FALSE" );
                        break;

                case GA_INT:
                        fprintf( stderr, "__%-7d", *(tabp->ga_variable) );
                        break;

                case GA_CHAR:
                        fprintf( stderr, "__%-7c", *(tabp->ga_variable) );
                        break;

                case GA_STRING:
			if( (*(char **)tabp->ga_variable) &&
			    (**(char **)tabp->ga_variable) ) {
				cc = (*(char **)tabp->ga_variable)[ 7 ];
				(*(char **)tabp->ga_variable)[ 7 ] = '\0';
				fprintf( stderr, "__%-7s", *(char **)(tabp->ga_variable) );
				(*(char **)tabp->ga_variable)[ 7 ] = cc;
				break;
			}

                case GA_PROC:
		case GA_COPY:
                case GA_HELP:
                        fprintf( stderr, "__%-7s", "NONE" );
                        break;
                }
/* what is this for ??!! kk
                cc = tabp->ga_errmsg[ 54 ];
		tabp->ga_errmsg[ 54 ] = '\0';
*/
                fprintf( stderr, " %-54s %c\n", tabp->ga_errmsg, headp->ga_ver );
/* what is this for ??!! kk
                tabp->ga_errmsg[ 54 ] = cc;
*/
        }
	pr_line( headp->ga_hor, 79 ); putc( '\n', stderr );
}


/*
 * Process command line arguments. Stripping all command line out
 * of argv. Return a new argc. If an error is found exit(1) is called
 * (getargs will not return) and a usable message is printed showing
 * all arguments in the table.
 */

int     getargs( argc, argv, headp, tabp, tabsize )
int     argc, tabsize;
char    **argv;
GA_ARG  *tabp;
GA_HEAD *headp;
{
        register int    nargc;
        register char   **nargv, *p;
        register GA_ARG *argp;
        int             nomenu = 0;
	char            prog_name[MAXSTR];

	strcpy( prog_name, argv[0] );

        for( nargc = 1, nargv = ++argv; --argc > 0; argv++ )
        {
                if( **argv != '-' )
                {
                        *nargv++ = *argv;
                        nargc++;
                }
                else
                {
                        p = (*argv) + 1;

                        while( *p )
                        {
                                if( argp = findarg( *p, tabp, tabsize ) )
                                {
                                        nomenu |= ( argp->ga_type & GA_NOMENU );
					p = setarg( prog_name, headp, argp, p, &argc, &argv );
                                }
                                else
                                {
					(* (PFI)(headp->ga_error) )( prog_name, *headp->ga_noarg, *p );
					pr_usage( prog_name, headp, tabp, tabsize );
                                        exit( 1 );
                                }
                        }
                }
        }

        if( !nomenu && nargc == 1 )
        {
		pr_usage( prog_name, headp, tabp, tabsize );
                exit( 1 );
        }
        else
                return( nargc );
}


/*
 * Find out if the requested argument is present in the argument list
 * given by the user. This is useful to test for "silent mode" -S etc.
 */

int     isarg( argc, argv, c )
int     argc;
char    **argv;
char    c;
{
        for( argv++; --argc > 0; argv++ )
                if( **argv == '-' && (*argv)[1] == c )
                        return( 1 );
        return( 0 );
}
