/* @(#)stoi.c              2.0 (Inge Berge Kristiansen) 85/11/28 */
/*
 * Convert string to integer. If string starts with 0x it is
 * interpreted as a hex number, else if it starts with a 0 it
 * is octal, else it is decimal. Conversion stops on encountering
 * the first character which is not a digit in the indicated
 * radix. *pp is updated to point past the end of the number.
 */

#include "sysconfig.h"


# define islower(c)        ( 'a' <= (c) && (c) <= 'z' )
# define toupper(c)        ( islower(c) ? (c) - ('a' - 'A') : (c) )

stoi(pp)
register char **pp;
{
        register int num = 0;
        register char *p;
        int sign = 1;

        p = *pp;

        while( *p == ' ' || *p == '\t' || *p == '\n' )
                p++;

        if( *p == '-' )
        {
                sign = -1;
                p++;
        }

        if( *p == '0' )
        {
                ++p;
                if( *p == 'x' || *p == 'X' )
                {
                        ++p;
                        while(  ( '0' <= *p && *p <= '9') ||
                                ( 'a' <= *p && *p <= 'f') ||
                                ( 'A' <= *p && *p <= 'F')  )
                        {
                                num *= 16;
                                num += ( '0' <= *p && *p <= '9' ) ?
                                        *p - '0'                  :
                                        toupper( *p ) - 'A' + 10  ;
                                p++;
                        }
                }
                else
                {
                        while( '0' <= *p && *p <= '7' )
                        {
                                num *= 8;
                                num += *p++ - '0';
                        }
                }
        }
        else
        {
                while( '0' <= *p && *p <= '9' )
                {
                        num *= 10;
                        num += *p++ - '0';
                }
        }
        *pp = p;
        return( sign * num );
}
