#include "sysconfig.h"
#include "np.h"


/*
 * Generate external reference for message, file and memory calls.
 */

extern_general( rtname, result_ref, prefix_name, proc_name, extwrite, extread )
	char *rtname;
	char *result_ref;
	char *prefix_name;
	char *proc_name;
	char *extwrite;
	char *extread;
{
	fprintf(header, "\nextern int %s%s_%s(), %s%s_%s();\n",
		prefix_name, proc_name, extwrite, prefix_name, proc_name, extread);
}


extern_file( rtname, result_ref, prefix_name, proc_name, extwrite, extread )
	char *rtname;
	char *result_ref;
	char *prefix_name;
	char *proc_name;
	char *extwrite;
	char *extread;
{
	fprintf(header, "\nextern void %s%s_%s(), %s%s_%s();\n",
		prefix_name, proc_name, extwrite, prefix_name, proc_name, extread);
}


/*
 * Generate external reference for message, file, memory and execution calls.
 */

extern_execution( rtname, result_ref, prefix_name, proc_name, extwrite, extread )
	char *rtname;
	char *result_ref;
	char *prefix_name;
	char *proc_name;
	char *extwrite;
	char *extread;
{
	fprintf(header, "\nextern long int %s%s_%s();\n",
		prefix_name, proc_name, extwrite);
	fprintf(header, "extern %s %s%s%s_%s();\n",
		rtname, result_ref, prefix_name, proc_name, extread);

	if( np_gen_prefix ) {
		fprintf(header, "extern int %s_%s();\n",
			proc_name, extwrite);
		fprintf(header, "extern %s %s%s_%s();\n",
			rtname, result_ref, proc_name, extread);
	}
}


/*
 * Generate external reference for a procedure call.
 */

extern_procedure( rtname, result_ref, prefix_name, proc_name )
	char *rtname;
	char *result_ref;
	char *prefix_name;
	char *proc_name;
{
	fprintf(header, "\nextern %s %s%s%s();\n",
		rtname, result_ref, prefix_name, proc_name);

	if( np_gen_prefix ) {
		fprintf(header, "extern %s %s%s();\n",
			rtname, result_ref, proc_name);
	}
}
