/* %W% %E% */
/*
 * Creation 1986 by Inge B. Kristiansen.
 *
 * 10/04/90 raw: put two arguments for translation functions
 * 24/04/90 raw: put one argument for "sizeof" functions
 */

#include "sysconfig.h"
#include <ctype.h>
#include "np.h"


/*
 * Generate defininitions for named types
 * and their size and translation functions.
 * Note that this is just a renaming;
 * the actual definition was done using a gensym
 * at the time the type was constructed.
 */

define_type(name, type)
	struct object *name, *type;
{
	enum constr tconstr;

	tconstr = type->t_constr;
	if (tconstr == C_PROCEDURE || tconstr == C_ERROR ||
	    tconstr == C_EXECUTION || tconstr == C_FILE ||
	    tconstr == C_MESSAGE || tconstr == C_MEMORY) {
		return;
	}
	declare(&values, name, type);
	if (tconstr == C_PRIVATE) {
		fprintf(header,
"\n\
typedef %s %s;\n", "char", rep(name));
		return;
	}
	fprintf(header, "\ntypedef %s %s;\n", rep(type), rep(name));
	if (tconstr == C_PREDEF)
		fprintf(header, "#define sizeof_%s(a) sizeof(%s)\n",
			rep(name), rep(type));
	else
		fprintf(header, "#define sizeof_%s(a) sizeof_%s(a)\n",
			rep(name), rep(type));
	fprintf(header, "\
#define externalize_%s(a,b) externalize_%s(a,b)\n\
#define internalize_%s(a,b) internalize_%s(a,b)\n",
		rep(name), rep(type),
		rep(name), rep(type));
}

