/*
 * Copyright (C) 1986 by Inge B. Kristiansen.
 * All rights reserved.
 */

#include "sysconfig.h"
#include "np.h"


/*
 * Global data structures maintained by this module.
 */

struct directory c_directory = {        /* Directory control block */
		NP_DHOSTNAME,           /* Default host name */
		NP_DPORTNUMBER          /* Default port number */
};

static char     *c_string = "directory";/* Used for error reporting */


/*
 * Set the host name.
 */

directory_host( name )
	struct object *name;
{
	check_attribute( c_string );
	c_directory.d_hostname = repfree( name );
}

/*
 * Set the port number.
 */

directory_port( number )
	struct object *number;
{
	check_attribute( c_string );
	c_directory.d_portnumber = reconsfree( number );
}

/*
 * Set the complete address.
 */

directory_address( name, number )
	struct object *name;
	struct object *number;
{
	directory_host( name );
	directory_port( number );
}
