/*
 * Copyright (C) 1986 by Inge B. Kristiansen
 * All rights reserved.
 *
 * 12.05.90 kk  Replaced NULL by '\0' in two cases.
 */

#include "sysconfig.h"
#include "np.h"


extern  char    yyfilename[MAXSTR];             /* The main input file */
extern  char    infilename[MAXSTR];             /* The current include file */
extern  int     yylineno;                       /* The current line number */

/*
 * Set up the line number and the file name according to the
 * directives passed from the preprocessor. The syntax of the directives
 * is checked by LEX. No checking is therefore needed in this routine.
 * The format of the directives is:
 *
 * # <linenumber> "[<filename>]"
 */
make_line_file(line)
	char *line;
{
	char *cp = line;                        /* Pointer to the line */
	char *ep;                               /* End pointer */

	for( ++cp; *cp == ' '; ++cp );          /* Skip spaces */
	for( ep = cp; *ep != ' '; ++ep );       /* Find end of line number */
	*ep = '\0';                             /* Set end mark */
	yylineno = atoi(cp) - 1;                /* Get the line number */

	for( cp = ++ep; *cp == ' '; ++cp );     /* Skip spaces */
	++cp;                                   /* Skip the " */
	for( ep = cp; *ep != '"'; ++ep );       /* Find end of file name */
	*ep = '\0';                             /* Set end mark */
	if( ep != cp ) {                        /* Empty file name? */
		strcpy(infilename,cp);          /* No, get the file name */
		input_file = infilename;        /* Set the pointer */
	} else {                                /* Yes, return to main file */
		input_file = yyfilename;        /* Set the pointer */
	}
}
