/*
 * Copyright (C) 1986 by Inge B. Kristiansen.
 * All rights reserved.
 */

#include "sysconfig.h"
#include "np.h"


/*
 * Global data structures maintained by this module.
 */

struct transport c_transport = {        /* Transport protocol control block */
		NP_TPNAME,              /* Default name */
		NP_TPLOAD,              /* Default load protocol */
		NP_TPDIRECTORY          /* Default directory protocol */
};

static char     *c_string = "protocol"; /* Used for error reporting */


/*
 * Set the protocol name.
 */

protocol_name( name )
	struct object *name;
{
	check_attribute( c_string );
	c_transport.tp_name = repfree( name );
}


/*
 * Set the directory protocol name.
 */

protocol_directory( name )
	struct object *name;
{
	check_attribute( c_string );
	c_transport.tp_directory = repfree( name );
}


/*
 * Set the load protocol name.
 */

protocol_load( name )
	struct object *name;
{
	check_attribute( c_string );
	c_transport.tp_load = repfree( name );
}
