 /*
 * Copyright (C) 1986 by Inge B. Kristiansen.
 * All rights reserved.
 * xx.05.90 kk  Version 2.0
 * 07.05.90 kk  removed obsolete code and commented out code related to name
 *              server and loader (to be reviewed).
 *              replaced negative error returns by returning (-1) and setting
 *              errno/errtype
 * CS - 11.09.2000 cleanup version - removed obsolete #ifdef
 */

#include "sysconfig.h"
#if !defined(NO_STDLIB_H)
#include <stdlib.h>
#endif
#if defined(LYNX2_2_1)
#include <oscalls.h>
#endif
#include <string.h>
#include "errtype.h"
#include "ncc.h"
#include "nc.h"

extern unsigned long nc_select_mask;
extern nct_service     nc_service[];
extern int ncr_imported;
extern int nc_disable_rpc;
/*
 * Free a service. That is detach from the remote server.
 */

int
free_service(int service_entry_id)
{
	struct nct_cservice *cd;
	register protocol *p;
	register int status;

	/* Get a pointer to the connection descriptor.                  */
	if( (service_entry_id < 0) || ((cd = nc_sgetptr( service_entry_id )) == 0) ) {
		RETURNERR(ENCNOSERVICE, ETNCRT, "no such service")
	}

	TRACE( serviceid && fprintf(stderr, "free_service sid = %d", service_entry_id));

	/* Get a pointer to the protocol to use.                        */
	p = cd->ncc_protocol;

	if ( p == (protocol *)0 ){
/*	printf(" free_s_tr: %x s_e_id, %x cd, %x prot %x, size %x %x\n", 
		service_entry_id, cd, p, NC_P_RX,
		sizeof(nct_service),sizeof(struct nct_service) ); 
*/
		RETURNERR(ENCNOSERVICE, ETNCRT, "wrong protocol pointer")
	}

	if (p != NC_P_RX) {
	   return(-1);
	} else {
		/*
		 * if this is a forked server we  kill it with ncr_freeserv()
		 * this call is unreliable
		 */
	    if (nc_service[service_entry_id].nc_servicetype == NC_IMPORTED)
		if ((cd->ncc_execution == NC_EX_DETACH) ||
		    (cd->ncc_execution == NC_EX_ANY) ||
		    (cd->ncc_execution == NC_EX_MASTER)){
		        if (!ncr_imported) {
                                import_ncr(cd->ncc_hostname, cd->ncc_port, cd->ncc_cd.timeout/1000);
                                ncr_imported = 1;
			}
			ncr_link(cd);

			if (! nc_disable_rpc) {
/* remove after 2.11 !!! */
			   /* ncr_util((long)NCR_EXIT); C.S. this is redundant*/
                          /* not unreliable call - avoid timeouts */
			    nc_calltmo(service_entry_id, 300L); /* added 13/10/2000 C.S. */
			    ncr_freeserv((long)NCR_EXIT);

			}
		}
		/* in principle rx is self-cleaning but to release      */
		/* storage from the free queues we call garbage collect */
		(*p->p_cleanup)();
	}

	/* Free the memory allocated to the service and the entry in    */
	/* the service entry table.                                     */
	nc_sdealloc( service_entry_id );
		
	/* Return an Ok status.						*/
	return( 0 );
}
