/* @(#)settrace.c  */
/*
 * Creation xx.05.90 by Kris Kostro
 * 25.09.90 kk  modified to set trace flags for any package with the same
 *              signal
 * 25.09.90 kk  Added code for OS9
 *
 */
/* signal interrupt routine to set trace flags for rx, nc and others */

#include "sysconfig.h"
#include <stdlib.h>
#if defined(LYNX2_2_1)
#include <oscalls.h>
#endif
#include <stdio.h>
#ifndef OS9
#if defined(VMS)
#define O_RDWR 2
#else
#include <fcntl.h>
#endif /* VMS */
#else
#include <modes.h>
#endif  /* OS9 */
#include <signal.h>
#ifdef BSDstrlib
#include <strings.h>
#else
#include <string.h>
#endif

#ifndef OS9
#ifdef SIGEMT
#define TRACESIG SIGEMT
#else
#define TRACESIG SIGUSR2
#endif
#define TMP "/tmp/usr_tr_"
#else /* OS9 */
/* arbitrary signal number for OS9 */
#define TRACESIG 76
#define TMP "/r0/usr_tr_"
#endif /* OS9 */

#define IDLIMIT 10
struct {
	unsigned long id;
	void (*proc)();
} settrtab[IDLIMIT] = {0};

void
user_trace(int x)
{
	int fd;
	char fname[24], pid[8], trace[100];
	extern char *strcat(char *, const char *);
	unsigned long id;
	int i;
#ifndef OS9
	signal(TRACESIG, user_trace);
#endif

	sprintf(pid, "%d", getpid());
	strcpy(fname, TMP);
	strcat(fname, pid);
/*
printf("opening for filename %s\n", fname);
*/
#ifndef OS9
	fd = open(fname, O_RDWR);
#else
	fd = open(fname, S_IREAD || S_IWRITE);
#endif
	/* read the trace id and flags */
	read(fd, &id, 4);
	read(fd, trace, 80);
/*
	printf("user_trace for %s flags %s at %x\n",&id, trace, (long)(trace));
*/
	close(fd);
	unlink(fname);
	/* find the corresponding procedure and call it */
	for (i = 0; i < IDLIMIT; i ++)
		if (id == settrtab[i].id) {
			(*(settrtab[i].proc))(trace);
			return;
		}
}


int
settrace(char *idstr, void (*proc) (/* ??? */))
{
	unsigned long id;
	int i;

#ifndef OS9
	signal(TRACESIG, user_trace);
#endif
	id = 0;
	strncpy((char *)&id, idstr, 4);

	for (i = 0; i < IDLIMIT; i ++)
		if (settrtab[i].id == 0) {
			settrtab[i].id = id;
			settrtab[i].proc = proc;
			return(0);
		}
	if (i == IDLIMIT)
		return(-1);
}
