/*
 * 11.10.90 Created by Kris Kostro
 * 08.07.92 C Scafuri : added conditional include sction for OS9
 * LP - 23.05.2000 - fixed in.h inclusion
 * 11.09.2000 - CS clean up version
 */

#include "sysconfig.h"
#include <string.h>
#if defined(OS9)
  #include <types.h>
  #include <INET/in.h>
#else
  #include <sys/types.h>
  #include <netinet/in.h>
#endif
#include "errtype.h"
#include "ncc.h"
#include "nc.h"


extern int ncr_imported;

/*
 * spawns off a new service calling ncr_newserv().
 */

int
nc_newserv(int service_entry_id)
{
	struct nct_cservice *cd, *newcd;
	int newsid, newport;
	register protocol *p;
	extern int _ncr_import;

	/* Get a pointer to the connection descriptor.                  */
	if( (service_entry_id < 0) || ((cd = nc_sgetptr( service_entry_id )) == 0) ) {
		RETURNERR(ENCNOSERVICE, ETNCRT, "no such service")
	}

	/* Get a pointer to the protocol to use.                        */
	p = cd->ncc_protocol;

	if (p != NC_P_RX) {
	   return (-1); /* CS - 11.09.2000 */
	} else {
                if (!ncr_imported) {
			/* default timeout will be overriden by ncr_link() */
			import_ncr(cd->ncc_hostname, cd->ncc_port, 0L);
                        ncr_imported = 1;
                }
		if (ncr_link(cd) < 0)
			return(-1);
		newport = ncr_newserv(NC_EX_TIMEOUT);
		TRACE(sockets && fprintf(stderr, "newserv returned port %d\n",newport));
		if (newport == (unsigned short)-1)
			return(-1);
		/* create new instance of the server */
		if( (newcd = (nct_cservice *)nc_allocate( sizeof(nct_cservice) )) == 0 ) {
			return(-1);
		}

		if( (newsid = nc_salloc( newcd, NC_IMPORTED )) < 0 ) {
			nc_deallocate( (char *)newcd );
			return(-1);
		}
		/* copy the cd to the newcd and set the new port number */
		memcpy(newcd, cd, sizeof(struct nct_cservice));
		newcd->ncc_cd.port = newcd->ncc_localport = ntohs(newport);
		newcd->ncc_execution = NC_EX_DETACH;
	}
	return( newsid );
}
