/*
 * 27.07.94     Written by Kris Kostro
 */

#include "sysconfig.h"
#include <stdio.h>
#if !defined(NO_STDLIB_H)
#include <stdlib.h>
#endif
#if (defined (_POSIX_SOURCE) || defined(POSIXsignal))
#include <unistd.h>
#include <sys/types.h>
#endif
#include <signal.h>
#include <sys/wait.h>

#include "errtype.h"



int
nc_fork()
{
	extern int nc_sigchld_ev; /* to check if signal handler set */
	extern int nc_setpgid;  /* allows disabling of setpgid for detached servers */
	extern int errno;
	int pid;
#if (defined (_POSIX_SOURCE) || defined(POSIXwait))
        pid_t chld_pid;
        int status;
#else
        int chld_pid;
        union wait status;
#endif

	if (nc_sigchld_ev == 0) {
printf("waiting for kids\n");
		/* no signal handler installed - we well just recuperate previous zombies */
#if (defined (_POSIX_SOURCE) || defined(POSIXwait))
  		chld_pid = waitpid (-1, &status, WNOHANG);
  		chld_pid = waitpid (-1, &status, WNOHANG);
#else
#if defined (BSDwait)
		chld_pid = wait3 (&status, WNOHANG, 0);
		chld_pid = wait3 (&status, WNOHANG, 0);
#endif
#endif
	}
	if ((pid = fork()) < 0) {       /* cannot fork */
		RETURNERR(errno, ETUNIX, "fork()");
	} else if (pid == 0) {          /* child */
#if !defined(_NO_SETPGID_)
	    if (nc_setpgid)
		setpgid(0, getpid());
#endif
#if defined(LYNX)
	    if (nc_setpgid)
		setpgrp(0, getpid());
#endif
		/*
		 * In child we close rx runtime and return 
		 */
		rx_closeup();
		return(0);
	}
	/* father returns the pid */
	return(pid);
}

