/*
 * Copyright (C) 1986 by Inge B. Kristiansen.
 * All rights reserved.
 */

#include "sysconfig.h"
#include "queue.h"


/*
 * Insert an element in a queue at a location given by the test()
 * function.
 */

/* VARARGS3 */
void
q_insert(register struct nc_queue *q, int (*test) (/* ??? */), register struct queue_item *x, queue_args args)
{
	register struct queue_item *prev, *cur;

	cur = q->head;
	if ((*test)((struct queue_item *)0, cur, x, &args)) {           /* goes before first item */
		q_ahead(q, x);
		return;
	}
	if (cur == 0)                                   /* doesn't go anywhere */
		return;
	do {
		prev = cur;
		cur = cur->link;
		if ((*test)(prev, cur, x, &args)) {
			/*
			 * Goes between prev and cur.
			 */
			prev->link = x;
			if ((x->link = cur) == 0) {
				q->tail = x;
			}
			return;
		}
	} while (cur != 0);
}
