/*
 * Definitions for queue package.
 */

/*
 * The queue_item structure is assumed to be a prefix of whatever structure
 * the client wishes to queue; i.e. the first field in the client's record
 * must be a pointer that the queue package may use.
 */
struct queue_item {
	struct queue_item *link;
};

/*
 * Queue structure.
 */
struct nc_queue {
	struct queue_item *head;
	struct queue_item *tail;
};

/*
 * Pointer to argument list for functions used in the package.
 */
typedef int *queue_args;

/*
 * External declarations.
 */
#ifdef _NO_PROTO
extern  void q_ahead();
extern  void q_atail();
extern  void q_delete();
extern  struct queue_item *q_find();
extern  void q_insert();
extern  int q_onqueue();
extern  struct queue_item *q_rhead();
extern  struct queue_item *q_rtail();
extern  void q_walk();
#else /* _NO_PROTO */
extern  void q_ahead(struct nc_queue *q, struct queue_item *x);
extern  void q_atail(struct nc_queue *q, struct queue_item *x);
extern  void q_delete(struct nc_queue *q, struct queue_item *x);
extern  struct queue_item *q_find(struct nc_queue *q, int (*fn) (/* ??? */), queue_args args);
extern  void q_insert(struct nc_queue *q, int (*test) (/* ??? */), struct queue_item *x, queue_args args);
extern  int q_onqueue(struct nc_queue *q, struct queue_item *x);
extern  struct queue_item *q_rhead( struct nc_queue *q);
extern  struct queue_item *q_rtail( struct nc_queue *q);
extern  void q_walk(struct nc_queue *q, int (*fn) (/* ??? */), queue_args args);
#endif /* _NO_PROTO */
