/*
 * All memory allocation for rx goes through these routines.
 * CS - 07.09.2000 : general heavy clenaup
 *                   removed all old dead code: RX_KERNEL etc... 
 */
#include "allincl.h"

int rx_ass_cnt = 0;

struct inout_pkt *
rx_alloc_packet(void)
{
	register struct inout_pkt * pk;

	pk = (struct inout_pkt *)q_rhead(&rx_glob.free_packets);
	if (pk != 0) {
		TRACE(allocation && fprintf(stderr,  "alloc_packet() found a free packet at %lx\n",
			(long)pk));
	} else {

		if ((pk = (struct inout_pkt *) malloc(sizeof(struct inout_pkt))) == 0)
			RETURNERRP((struct inout_pkt *)0, errno, ETUNIX, "malloc()");
		TRACE(allocation && fprintf(stderr,
			"alloc_packet() allocated %d at %lx\n",
			sizeof(struct inout_pkt), (long)pk));
	}
	return(pk);
}

void
rx_free_packet(char *pk)
{
	if (pk != NULL) {
		if (rx.freelists) {
				q_atail(&rx_glob.free_packets, (struct queue_item *)pk);
			TRACE(allocation && fprintf(stderr,
				"free_packet() enqued packet at %lx\n", (long)pk));
		} else {
			free(pk);
			TRACE(allocation && fprintf(stderr,
				"free_packet() freed packet at %lx\n", (long)pk));
		}
	}
}

struct association *
rx_alloc_assoc(void)
/*
 * Allocate memory for the association descriptor or get a new one
 * from the free queue. Set the initial values.
 */
{
	register struct association *a;
	int i;

	a = (struct association *)q_rhead(&rx_glob.free_assoc);
	if (a == NULL) {
		if (rx_ass_cnt > RX_MAX_ASS_CNT) {
			/* prevent free queue from explode */
			rx_garbage_collect();
			a = (struct association *)q_rhead(&rx_glob.free_assoc);
		}
	}
	if (a == NULL) {
	    if ((a = (struct association *)malloc(sizeof(struct association))) == (struct association *)0)
		RETURNERRP((struct association *)0, errno, ETUNIX, "malloc()");
	    TRACE(allocation && fprintf(stderr,
		"rx_alloc_assoc() allocated %d at %lx\n",
		sizeof(struct association), (long)a));
	}
	a->tm = 0;
	a->state = SENDING;
	a->hdr.magic = RX_MAGIC;
	a->readp = NULL;
	a->in_pkts.head = a->in_pkts.tail = (struct queue_item *)0;
	q_atail((struct nc_queue *)&rx.ass.head, (struct queue_item *)a);
	rx_ass_cnt ++;
	return(a);
}

void
rx_free_assoc(struct association *a)
{
	if (a != NULL) {
	    q_delete((struct nc_queue *)&rx.ass.head, (struct queue_item *)a);
	    if (rx.freelists) {
		q_atail(&rx_glob.free_assoc, (struct queue_item *)a);
	    } else {
		free(a);
		TRACE(allocation && fprintf(stderr,
			"rx_free_assoc() freed at %lx\n", (long)a));
	    }
	    rx_ass_cnt --;
	}
}


