/*
 * Client only part of rx.
 *
 * LP - 23.05.2000 - variable "one" is a char! (was int)
 * CS - 07.09.2000 : general heavy clenaup
 *                   removed all old dead code: RX_KERNEL etc...
 */

#include "allincl.h"

int
rx_unrel(struct rx_call_descr *cd)
{
	/*
	   This call is the unreliable version of rx_call(), also used as broadcast.
	   No reply is expected and segments are not retransmitted.
	*/
	long status;
	register struct association *a;
	int i, len;
	struct timeval time_now;
	char one = 1;  /* LP - was int */
	TRACE(calls && fprintf(stderr, "rx_unrel(): ") && print_cd(cd));

	/* search the association in the active list */
	for (a = (struct association *)RXHEAD; (char *)a != NULL &&
		(a->addr_peer.host != cd->host || a->addr_peer.port != cd->port ||
		    a->type != RX_CLIENT);
		a = (struct association *)a->link);
	if ((char *) a == NULL) {
		/* not found, alloc a new one */

		a = rx_alloc_assoc();

		TRACE(assoc && fprintf(stderr, "allocated new association at %x for the first call\n",
			(long)a));

		a->type = RX_CLIENT;
		a->ourwindow = rx_glob.window;
		a->hiswindow = RX_INIT_WINDOW;
		a->addr_peer.host = cd->host; a->addr_peer.port = cd->port;
	}
	else {

		TRACE(assoc && fprintf(stderr, "found active association at %x for addr %s\n",
			(long)a, print_ipaddr(&a->addr_peer)));
		if (a->state == RECEIVED || a->state == IDLE || a->state == SENT || a->state == ERROR_STATE) {
			a->tm = 0;
			a->state = SENDING;
		} else
			RETURNERR(EPENDING, ETRX, "call pending")
		/* cleanup possible reply of previous call (timed out but received)
		   or not read in  */

		while (a->in_pkts.head != (struct queue_item *)0)
			free(q_rhead(&a->in_pkts));

	}
	a->seq = 0;     /* on sending seq is the sequence not yet ack'ed */
	a->call_number = (rx_glob.call_number ++);

	a->hdr.call_number = ntohl(a->call_number);
	a->hdr.pk_type = RX_CALL_DATA;

	a->rmsg = cd->rmsg;
	a->rlen = cd->rlen;
	a->prot_flags = cd->flags;

	if (a->addr_peer.host == htonl(INADDR_BROADCAST)) {

	    if ((status = setsockopt(rx.sd, SOL_SOCKET, SO_BROADCAST, \
                               &one, sizeof(one))) < 0)
		RETURNERR(errno, ETUNIX, "setsockopt()");
	    TRACE(calls && fprintf(stderr, "setting broadcast options\n") );
	}

	/* send packets */
	a->last_seq = (cd->slen + RX_SIZE - 1)/RX_SIZE - 1;

	/* loop until everything sent or error */
	while (a->state == SENDING) {
		/* multisegment send except of last segment */
		for (i = 0; (a->seq + i < a->last_seq) && (i + 1 < a->hiswindow); i++) {
			a->hdr.seq_number = ntohs(a->seq + i);
			a->hdr.flags = UNREL_FLG;

			if ((status = send_segment(
			    a, cd->smsg + ((a->seq + i) * RX_SIZE), RX_SIZE)) < 0) {
				rx_cleanup_ass(a);
				return(status);
			}

		}
		/* last segment of the multisegment send */
		if (a->seq + i == a->last_seq) {
			/* last segment of the call */
			a->hdr.flags = NOREPL_FLG | LAST_SEGMENT | UNREL_FLG;

			if ((len = cd->slen % RX_SIZE) == 0)
				len = RX_SIZE;
		} else {
			/* last segment of the set */
			len = RX_SIZE;
		}
		a->hdr.seq_number = ntohs(a->seq + i);

		if ((status = send_segment(
		    a, cd->smsg + ((a->seq + i) * RX_SIZE), len)) < 0) {
			rx_cleanup_ass(a);
			return(status);
		}

		a->state = SENT;
	}
	if (a->state == ERROR_STATE) {
		rx_cleanup_ass(a);
		RETURNERR(a->error, ETRX, "");
	}
	cd->call_number = a->call_number;
	a->state = IDLE;
	return(0);

}

