/*
 * usage: nh machine [timeout [nc traceflags rx traceflags]]
 */
#include <stdio.h>
	char input_string[100] = "abcde";

main(argc, argv)
	int argc;
	char **argv;
{
	char *reverse_string_pointer;
	extern char *reverse_string();
	int sid, newsid;
	long timeout;

	if ((argc < 2) || (argc > 5)) {
		fprintf(stderr, "Usage: %s machine [timeout [nc traceflags rx traceflags]]\n", argv[0]);
		exit(1);
	}

	if (argc >= 3) {
		timeout = (atoi(argv[2]));
		printf("set call timeout to %d milliseconds\n", timeout);
	} else
		timeout = -1;
	if (argc >= 4)
		nc_trace(argv[3]);
	if (argc >= 5)
		rx_trace(argv[4]);


	if ((sid = import_nh(argv[1])) < 0 ) {
		nc_perror("import_nh()");
		exit( 1 );
	}
	if (timeout != -1)
		nc_calltmo(sid, timeout);
	for (;;) {
		if ((newsid = nc_newserv(sid)) == -1) {
			nc_perror("nc_newserv()");
			exit(1);
		}
fprintf(stderr, "new sid is %d\n", newsid);
		bind_nh(newsid);
		if((reverse_string_pointer = reverse_string(input_string)) == (char *)0) {
			nc_perror(argv[0]);
			exit(1);
		} else
			nc_deallocate( reverse_string_pointer );
		if ((free_nh(newsid) == -1)) {
			nc_perror("free_nh()");
			exit(1);
		}
exit(0);
	}
}
