/*
 * usage: nh machine [timeout [nc traceflags rx traceflags]]
 */
#include <stdio.h>

main(argc, argv)
	int argc;
	char **argv;
{
	char input_string[100];
	char *reverse_string_pointer;
	extern char *reverse_string();
	int sid;
	long timeout;
	int retr, tmo;

	if ((argc < 2) || (argc > 8)) {
		fprintf(stderr, "Usage: %s machine [timeout [nc traceflags rx traceflags [retr tmo]]]\n", argv[0]);
		exit(1);
	}

	if (argc >= 3) {
		timeout = (atoi(argv[2]));
		printf("set call timeout to %d milliseconds\n", timeout);
	} else
		timeout = -1;
	if (argc >= 4)
		nc_trace(argv[3]);
	if (argc >= 5)
		rx_trace(argv[4]);

	if ((sid = import_nh(argv[1])) < 0 ) {
		nc_perror("import_nh()");
		exit( 1 );
	}
	if (timeout != -1)
		nc_calltmo(sid, timeout);
	do {
		/* to test rx timeout customisation */
		if (argc >= 7) {
			rx_gettmo(&retr, &tmo);
			printf("previous RX retransmissions values are %d %d\n", retr, tmo);
			rx_settmo(atoi(argv[5]), atoi(argv[6]));
			rx_gettmo(&retr, &tmo);
			printf("current RX retransmissions values are %d %d\n", retr, tmo);
		}
		printf("enter string:    ");
		for( ; gets(input_string) == (char *)0 ; );
		if(strlen(input_string)<=0)break;
		if((reverse_string_pointer = reverse_string(input_string)) == (char *)0) {
			nc_perror(argv[0]);
			reverse_string_pointer = input_string; /* to avoid coredump */
		} else{
			printf("reversed string: %s\n", reverse_string_pointer );
			free(reverse_string_pointer);
	        }
	} while (strlen(input_string)>0);
	free_nh(sid);

#ifdef MULTIHOST
    for (;;) {
	char newhost[20];
	printf("enter next host:");
	for( ; gets(newhost) == (char *)0 ; );

	if ((sid = import_nh(newhost)) < 0 ) {
		nc_perror("import_nh()");
		exit( 1 );
	}
	if (timeout != -1)
		nc_calltmo(sid, timeout);
	do {
		printf("enter string:    ");
		for( ; gets(input_string) == (char *)0 ; );
		if((reverse_string_pointer = reverse_string(input_string)) == (char *)0) {
			nc_perror(argv[0]);
			exit(1);
		} else
			printf("reversed string: %s\n", reverse_string_pointer );
	} while (*reverse_string_pointer != 0);
	free_nh(sid);
    }
#endif /* MULTIHOST */
}
