/* %W% %E% */
/*
 * Origin       Eric Cooper UCB
 *
 * 29/05/90 (raw) call tm_initelapsed if not initialized
 * 26.06.90 kk  Two types of time interface are used: BSDtime (gettimeofday())
 *              and SYSVtime (time()).
 */

#include "tm_include.h"
#include "stdio.h"


/*
 * Global variables maintained by this module.
 */

static  struct timeval last_time={0};
static  struct timeval this_time={0};

static int tminit=0;

/*
 * Initialize for elapsed time measurement.
 */

void
tm_initelapsed(void)
{
	tminit=1;
	tm_now(&last_time);
}


/*
 * Print the measured elapsed time.
 */

int
tm_printelapsed(void)
{
	/* Initialize if not yet done */
	if(tminit == 0)
		tm_initelapsed();

	tm_now(&this_time);
#if !defined(SYSVtime)
	if ((last_time.tv_usec = this_time.tv_usec - last_time.tv_usec) < 0) {
		last_time.tv_usec += 1000000;
		last_time.tv_sec -= 1;
	}
#else
	last_time.tv_usec = 0L;
#endif
	last_time.tv_sec = this_time.tv_sec - last_time.tv_sec;
	tm_printtimeval(&last_time);
	last_time = this_time;
}
