/* %W% %E% */
/*
 * Origin       Eric Cooper UCB
 *
 * 13/02/89 (raw) printout for os9 added
 * 26.06.90 kk  Three types of signal interface are defined:
 *              BSDsignal (sigvec() etc.) SYSV3signal (sigset() etc.)
 *              and SYSVsignal (only rudimentary signal())
 *              All systems should define one of the three
 */
 
#include <signal.h>
#include "tm_include.h"
#include "stdio.h"

/*
 * Print an interrupt as it happens.
 */

int
tm_printinterrupt(char *name, int entering)
{
	tm_printelapsed();

#if defined(_POSIX_SOURCE)
       {
	   sigset_t oset;

	   if ( sigprocmask(SIG_SETMASK, NULL, &oset) != 0)
	      if (entering)
		fprintf(stderr, "> %s (mask 0x%x)\n", name, sigblock(0));
	      else
		fprintf(stderr, "< %s (mask 0x%x)\n", name, sigblock(0));
	}
#else
#if defined(BSDsignal)
       if (entering)
		fprintf(stderr, "> %s (mask 0x%x)\n", name, sigblock(0));
       else
		fprintf(stderr, "< %s (mask 0x%x)\n", name, sigblock(0));
#else
	if (entering)
		fprintf(stderr, "> %s\n", name);
	else
		fprintf(stderr, "< %s\n", name);
#endif
#endif
}
