/* %W% %E% */
/*
 * Origin       Eric Cooper UCB
 *
 * 26.06.90 kk  Three types of signal interface are defined:
 *              BSDsignal (sigvec() etc.) SYSV3signal (sigset() etc.)
 *              and SYSVsignal (only rudimentary signal())
 *              All systems should define one of the three
 *              Two types of time interface are used: BSDtime (gettimeofday())
 *              and SYSVtime (time()).
 *              defined SIGALRM if not already defined (fix for os9)
 */


/*
 * This is necessary for the PC/AT which has different pointer size for
 * the large and small model. Also to pass zero as an argument.
 */
#define ZERO 0L

/*
 * Handle things differently if debug is enabled.
 */
#ifdef DEBUG

/*
 * Tracing facility.
 */
#define TRACE(x) if (tm_tracingon) x; else

/*
 * Assertion facility.
 */
#define ASSERT(x) if (!(x)) { \
	fprintf(stderr, "File %s, line %d: assertion x failed.\n", \
		__FILE__, __LINE__); \
	fflush(stdout); \
	fflush(stderr); \
	abort(); } else

#else /* DEBUG */

/*
 * Ignore tracing and do not print assertions.
 */
#define TRACE(x)
#define ASSERT(x)
#endif /* DEBUG */

/*
 * Mask for blocking interrupts.
 */
#if defined(SIGAIO)
#define TM_INTERRUPTMASK ((1<<(SIGALRM-1))|(1<<(SIGAIO-1)))
#else
#define TM_INTERRUPTMASK ((1<<(SIGALRM-1))|(1<<(SIGIO-1)))
#endif

/* special fix for os9 */
#if defined(OS9)
#if !(defined(SIGALRM))
#define SIGALRM 14
#endif
#endif

extern int     tm_tracingon;
extern  int tm_traceinterrupts;
extern  int tm_tracetimers;
extern  struct nc_queue tm_queue;
