/* @(#)trace.c  */
/*
 * Creation xx.05.90 by Kris Kostro
 * 25.09.90 kk  modified to set trace flags for any package with the same
 *              signal
 * 25.09.90 kk  Added code for OS9
 *
 */
/* sets trace flags for rx, nc and others */

#include "sysconfig.h"
#ifndef OS9
#include <fcntl.h>
#else
#include <modes.h>
#endif
#include <signal.h>
#ifdef BSDstrlib
#include <strings.h>
#else
#include <string.h>
#endif

#ifndef OS9
#ifdef SIGEMT
#define TRACESIG SIGEMT
#else
#define TRACESIG SIGUSR2
#endif
#define TMP "/tmp/usr_tr_"
#else /* OS9 */
/* arbitrary signal number for OS9 */
#define TRACESIG 76
#define TMP "/r0/usr_tr_"
#endif /* OS9 */

#ifdef OS9
#define perror(y) printf("%s: error %x\n", y, errno);
#endif

main(argc, argv)
	int argc;
	char **argv;
{
	int fd;
	char fname[24];
	char flags[10];
	unsigned long id = 0;
	extern int errno;

	if (argc > 4 || argc < 3) {
		goto usage;
	}
	strcpy(fname, TMP);
	strcat(fname, argv[1]);
#ifndef OS9
	if ((fd = open(fname, O_CREAT | O_RDWR, 0777)) == -1) {
		perror("open()");
		close(fd);
	}
#else
	if ((fd = creat(fname, S_IWRITE)) == -1) {
		perror("creat()");
		close(fd);
	}
#endif
	strncpy((char *)&id, argv[2], 4);
	if (write(fd, &id, 4) == -1)
		perror("write()");
	if (argc == 4)
		strcpy(flags, argv[3]);
	else
		strcpy(flags, "");
	if (write(fd, flags, strlen(flags) + 1) == -1)
		perror("write()");
	if (kill(atoi(argv[1]), TRACESIG) == -1) {
		perror("kill()");
		close(fd);
/*                unlink(fname);
*/
	}
	exit(0);
usage:
	printf("Usage: %s pid traceid [flagstring] (rx [c][s][p][x][a][t][i])\n", argv[0]);
	exit(1);

}
